﻿package{
	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;
	
	public class IntuitiveDrawer extends Sprite{
		
		var bg:BitmapData;
		var container:Bitmap;
		var line:Sprite;
		var lineCopy:Sprite;
		var lineStack:Array; 
		var matrix:Matrix;
		//var bg2:BitmapData;
		//var container2:Bitmap;
		var line2:Sprite;
		var lineCopy2:Sprite;
		var lineStack2:Array; 
		var matrix2:Matrix;
		
		public function IntuitiveDrawer():void{
			
			bg = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			container = new Bitmap(bg);
			addChild(container);
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine2);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine2);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine2);
		
			}
			
		private function startDessine(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME,floodit);
			matrix = new Matrix();
			line = new Sprite();
			lineStack = new Array();
			line.graphics.lineStyle(1,0xcccccc,0.1);
			line.graphics.moveTo(e.stageX,e.stageY*10);
			lineStack.push(new Array(e.stageX*10,e.stageY));
			}
			private function dessine(e:MouseEvent):void{
			if(line != null){
				line.graphics.lineTo(e.stageX,e.stageY);
				lineStack.push(new Array(e.stageX,e.stageY));
				addChild(line);
				}
			}
			private function stopDessine(e:MouseEvent):void{
			if(line != null){
				removeChild(line);
				line = null;
				floodFill();
			}
			}
			private function floodFill():void{
			lineCopy= new Sprite();
			lineCopy.graphics.lineStyle(1,buildColor(),0.1);
			lineCopy.graphics.moveTo(lineStack[0][0],lineStack[0][1]);
			for(var i:uint=1;i<lineStack.length;i++){
				lineCopy.graphics.curveTo(width/4,height/4,lineStack[i][0],lineStack[i][1]);
				}
			addEventListener(Event.ENTER_FRAME,floodit);
		}
		private function floodit(e:Event):void{
			matrix.scale(0.9999,1.005);
			bg.draw(lineCopy,matrix);
			}
			private function buildColor():uint{
			for(var j:int=1;j<255;j++);
			var R:uint = Math.round(Math.random()*j);
			var G:uint = Math.round(Math.random()*j);
			var B:uint = Math.round(Math.random()*j);
			var nbr:uint =  R << 16 | G << 8 | B;
			return nbr;
			}
			
		private function startDessine2(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME,floodit2);
			matrix2 = new Matrix();
			line2 = new Sprite();
			lineStack2 = new Array();
			line2.graphics.lineStyle(1,0xcccccc,0.1);
			line2.graphics.moveTo(e.stageX*10,e.stageY*10);
			lineStack2.push(new Array(e.stageX,e.stageY*10));
			}
		private function dessine2(e:MouseEvent):void{
			if(line2 != null){
				line2.graphics.lineTo(e.stageX,e.stageY);
				lineStack2.push(new Array(e.stageX,e.stageY));
				addChild(line2);
				}
		}
		private function stopDessine2(e:MouseEvent):void{
			if(line2 != null){
				removeChild(line2);
				line2 = null;
				floodFill2();
			}
		}
		private function floodFill2():void{
			lineCopy2= new Sprite();
			lineCopy2.graphics.lineStyle(1,buildColor(),0.1);
			lineCopy2.graphics.moveTo(lineStack2[0][0],lineStack2[0][1]);
			for(var l:uint=1;l<lineStack2.length;l++){
				lineCopy2.graphics.curveTo(lineStack2[l][0],lineStack2[l][1],width/4,height/4);
				}
			addEventListener(Event.ENTER_FRAME,floodit2);
			}		
		private function floodit2(e:Event):void{
			//matrix2.scale(0.9999,1.005);
			matrix2.translate(1.5,1.5);
			bg.draw(lineCopy2,matrix2);
			}
			
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		
		
		private function buildColor2():uint{
			for(var k:int=1;k<255;k++);
			var R2:uint = Math.round(Math.random()*k);
			var G2:uint = Math.round(Math.random()*k);
			var B2:uint = Math.round(Math.random()*k);
			var nbr2:uint =  R2 << 16 | G2 << 8 | B2;
			return nbr2;
			}
		}
		}
	